/* s3tuid technologies, inc.
   29/03/2002 - rio.de.janeiro (brasil)

	bigeye, is a raw socket/port based/sniffer/ pretend 
        to be Honeypot,  connection  logger. It will try to
	intercept all connections directed to a host.

	It can either use raw sockets to analyze tcp/udp/icmp
	connections (only header info), a binded socket to  a 
	port  that will receive completed  connections,   can 
	analyze the  data  received   against a signature  or 
	a file full of intrusion detection signatures  (still
	pretty primitive) and a no treatment/decode sniffer.

	It can also simulate the looks and feel of a real ap-
	plication service (ftp/http) and grab the information
	in a honeypot environment, without the needs to actu-
	ally deploy one computer to it...  See emulate.c  for 
	more information...
 
 UPDATE: Added a more support for honeypot/IDS, now you can set
	 bigeye to listen for  connections and search for  data
	 specified in  a signature file. This is  good  because
	 now you can watch the willey hacker trying  to exploit
	 host without any success.

	  ./bigeye -b -o tcp -p 80 -f ids.rules -l log

 UPDATE: implemented a very rustic sniffer, just because it was
	 lacking something of this sort, however im working  on
	 improving this one at the time..  it will dump  every-
	 thing that goes across the wire (no decoding)  so  you 
	 you'll see lots of nasty chars.. just ignore them =)
	
	./bigeye -S -i <device>

	 and there she goes...

 I'm not good with words, therefor, read the program to see all
 of its capabilities.

 [1] - it's was based on a few programs, tcplog.c udplog.c icmplog.c
       sniffer construction text by Chad Renfro and few sniffer  out
       there also...
 [2] - recvtimeout() was coded by pilot@monkey.org
 [3] - i researched a few sniffer on the wild... however lots of them
       exists and i used pieces of most of them to assemble one.

 	I've taken all the structures from linux/tcp.h;udp.h;icmp.h
	from Red Hat 7.1 (i dont know the version of libc), but  it
	seems to work fine.

 TODO:
       ****  create a more complex signature rule file
	***  improve -S (sniffer) function
	 **  documentation
 mail me if you want to help!!!


	* 19/07/2002 - minor security fix, that could pos-
		       sible lead to remote exploitation

	* 25/06/2002 - just did a cleaning job at bigeye.c
		       and emulate.c, fixed a few warnings
		       problems and compatability problems

	* 22/06/2002 - -L options added, for directory lis
		       ting and a few updates were made ;)

	* 30/05/2002 - added setsockopt() calls to  enable
		       SO_REUSEADDR so that those big pro-
		       blems while trying to reload bigeye
		       wont happen ;)

	* 27/05/2002 - well,  thanks to W. Richard Stevens
		       i've updated a few of bigeye's  so-
		       cket dependecies, and  now it  runs
		       in a more "professional" way (?)
		       Hope you guys like it... ;)
		
	* 05/05/2002 - bigeye.c was felling a little  left
		       out, so i added something to -r opt
		       Now you can  specify  the port  you 
		       want bigeye  to listen for  connec-
		       tions in a rawsocket mode... eg.:

			./bigeye -o tcp -p 21 -r

		       will listen for any activety at po-
		       rt 21, via rawsocket (dont  confuse
		       this with 'sniffer'. it aint one)
		       ps.: you will keep seeing the IP of
		       ppl that connects to you, you  only
		       wont see strictly (verbose?) infor-
		       mation on that connection... 

	* 31/03/2002 - added a support for hexdump, copied
		       from zodiac's code, so any  credits
		       goes to him/it/or form...

	* 30/03/2002 - finished  the support for -l (log)
		       option while using -r (raw socket)
		       now you can log all header info to
		       a file for further analisys.

	* 29/03/2002 - finally i added a daemon function,
		       very simple and effective, it's by
		       now fully compliant with -b option
		       im still  working on -r. Note that
		       it  is only worth to use this fun-
		       tion with -l  on, or else you wont
		       see whats going on ;)
		       Also fixed a bug (minor) in  which
		       the recvbuffer[] wasnt NULL termi-
		       nated, dumping other data on memory
		       that didnt came with the connection
		 
	* 28/03/2002 - added a support for signature files
		       this will  allow a bigger range  of
		       signatures to be used, allowing you
		       to catch the willey hacker  in  the 
		       wild trying to break into your sys-
		       tem.

	* 18/03/2002 - added a no treatment/decode sniffer
		       just so that i could use this tool 
		       more often... Improvements are sure
		       to come on 0.2 version maybe...

	* 05/03/2002 - updated, i must be smoking too much
		       because i forgot to release bigeye,
 		       with udp support for -b... w00aw!
		       Now fixed!!!

thanks: ectos, electr0n, Nixer, alvaro, dm_, mips, for testing
	the application whenever possible... ;)

setuid@violating.us
http://setuid.n3.net - chmod +s technologies, inc.
brasilian style pra gringo ver, porra!!!
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <getopt.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/if.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>


#define TIMEOUTTED 12
#define MAXBUFLEN 1024
#define BACKLOG 8
#define NOFILE 1024
#define MAXFD 64

int rawsock(int proto,  char *port);
int portbase(char *port, int proto);
int sniff_all(char *interface);
int compare(char *buff);
int demon(void);
int recvtimeout(int s, char *buf, int len, int timeout);
int read_ids(char *recvbuff);
int emulate_main ( int service, char *prt, char *two, char *four, char *five, 
		   char *lfile, int h, char *ftpbanner );

void usage(char *program);
void log(char *connection, char *signature, 
	 char *protocol, char *data, char *port);
void log_rawsock(char *connection, int proto, int lenght,
		 int source_port, int dest_port, int cksum,
		 int flag, int ttl, int icmp_type);
void hexdump(char *desc, unsigned char *data, unsigned int amount);
void sighand(int signo);
char *chomp(char *string);



char *signature, *idsfile, *logfile, idstemp[1030], *four, *two, *five, *listfile;
int sigctrl, idsctrl, logctrl, nullids, hex, emulate = 0, daectrl = 0;
int on = 1, sizeon = sizeof(on), http = 0, ftp = 0;

struct tm *ptr;
time_t lt;

struct ip {
	unsigned int		ip_lenght:4;
	unsigned int		ip_version:4;
	unsigned char		ip_tos;
	unsigned short		ip_total_lenght;
	unsigned short 		ip_id;
	unsigned short		ip_flags;
	unsigned char		ip_ttl;
	unsigned char		ip_protocol;
	unsigned short		ip_cksum;
	unsigned int		ip_source;
	unsigned int 		ip_dest;
};

struct tcp {
	unsigned short	tcp_source_port;
	unsigned short	tcp_dest_port;
	unsigned int	tcp_seqno;
	unsigned int	tcp_ackno;
	unsigned int 	tcp_res1:4,
	tcp_hlen:4,
	tcp_fin:1,
	tcp_syn:1,
	tcp_rst:1,
	tcp_psh:1,
	tcp_ack:1,
	tcp_urg:1,
	tcp_res2:2;
	unsigned short	tcp_winsize;
	unsigned short	tcp_cksum;
	unsigned short	tcp_urgent;
};

struct udphdr {
	unsigned short	source;
	unsigned short	dest;
	unsigned short	len;
	unsigned short 	check;
};

struct icmphdr {
	unsigned char	type;
	unsigned char	code;
	unsigned short	checksum;
	union {
		struct {
			unsigned short id;
			unsigned short sequence;
		} echo;
		unsigned int	gateway;
		struct {
			unsigned short __unused;
			unsigned short mtu;
		} frag;
	} un;
};


int main(int argc, char *argv[]) 
{
	int c, proto = 0, rawsck = 0, twoctrl = 0, fivectrl = 0;
	int port_based = 0, sniff = 0, fourctrl = 0;
	int banctrl = 0;
	char *port = NULL;
	char *interface = NULL;
	char *protocol = NULL;
	char *banner = NULL; 
	FILE *fptest;

	if(argc < 2) {
		usage(argv[0]);
		exit(0);
	}

	while((c = getopt(argc,argv, "o:e:p:s:i:f:L:l:4:2:5:n:rhSbdx")) != EOF)
	switch(c) {
		case 'h':
			usage(argv[0]);
			exit(0);
			break;
		case 'b':
			port_based = 1;
			break;
		case 'r':
			rawsck = 1;
			break;
		case 'o':
			protocol = optarg;
			if(strlen(protocol) > 25) {
			 fprintf(stderr,"protocol name too long\n");
			 exit(0);
			}

			if(strcmp(protocol, "tcp") == 0) {
				proto = 1;
				break;
			}
			
			if(strcmp(protocol, "udp") == 0) {
				proto = 2;
				break;
			} 

			if(strcmp(protocol, "icmp") == 0) {
				proto = 3;
				break;
			} else {
				fprintf(stderr,"-- Protocol not supported\n");
				exit(0);
			}
			break;
		case 'p':
			port = optarg;
			break;
		case 's':
			if(strlen(optarg) > 499) {
				fprintf(stderr,"signature too long\n");
				exit(0);
			}
			sigctrl = 1;
			signature = optarg;
			break;
		case 'S':
			sniff = 1;
			break;			
		case 'i':
			if(strlen(optarg) > 16) {
			 fprintf(stderr,"device name too long\n");
			 exit(0);
			}
			interface = optarg;
			break;
		case 'f':
			if(strlen(optarg) > 255) {
			 fprintf(stderr,"fakemsg/signature filename too long\n");
			 exit(0);
			}


			idsfile = optarg;
			idsctrl = 1;

			if((fptest = fopen(idsfile,"r")) == NULL) {
				printf("fopen: Unable to open IDS signature file\n");
				exit(0);
			}
			fclose(fptest);
			break;
		case 'l':
			if(strlen(optarg) > 255) {
			 fprintf(stderr,"logfile name too long\n");
			 exit(0);
			}

			logfile = optarg;
			logctrl = 1;
			break;
		case 'e':
			if(strlen(optarg) > 10) {
			 fprintf(stderr,"service name too long\n");
			 exit(0);
			}

			if(strcmp(optarg, "http") == 0)
			http = 1;
		
			if(strcmp(optarg, "ftp") == 0)
			ftp = 1;

			emulate = 1;
			break;
		case 'd':
			daectrl = 1;
			break;
		case 'x':
			hex = 1;
			break;
		case '2':
			if(strlen(optarg) > 255) {
			 fprintf(stderr, "fakemsg filename too long\n");
			 exit(0);
			}

			two = optarg;
			twoctrl = 1;

			if((fptest = fopen(two, "r")) == NULL) {
			 	perror("fopen");
				exit(0);
			}
			fclose(fptest);
			break;
		case '4':
			if(strlen(optarg) > 255) {
			 fprintf(stderr,"fakemsg filename too long\n");
			 exit(0);
			}


			four = optarg;
			fourctrl = 1;

			if((fptest = fopen(four,"r")) == NULL) {
				perror("fopen");
				exit(0);
			}
			fclose(fptest);
			break;	
		case '5':		
			if(strlen(optarg) > 255) {
			 fprintf(stderr,"fakemsg filename too long\n");
			 exit(0);
			}


			five = optarg;
			fivectrl = 1;

			if((fptest = fopen(five,"r")) == NULL) {
				perror("fopen");
				exit(0);
			}
			fclose(fptest);
			break;	
		case 'L': 
			if(strlen(optarg) > 255) {
			 fprintf (stderr,"list filename too long\n");
			 exit(0);
			}

			listfile = optarg;

			if((fptest = fopen(listfile,"r")) == NULL) {
				perror("fopen");
				exit(0);
			}
			fclose(fptest);

			break;
		case 'n':
			if(strlen(optarg) > 255) {
			 fprintf(stderr,"banner filename too long\n");
			 exit(0);
			}

			banner = optarg;
			banctrl = 1;
			
			if((fptest = fopen(banner,"r")) == NULL) {
				perror("fopen");
				exit(0);
			}
			fclose(fptest);
			break;
		default:
			usage(argv[0]);
	}

	signal(SIGPIPE,SIG_IGN); /* for the quiters     */
	signal(SIGCHLD,sighand); /* for the non-quiters */


	if(daectrl == 1) demon();

	if(emulate == 1) { sigctrl = 0; idsctrl = 0; }
	if(idsctrl == 1) sigctrl = 0;
	if(sigctrl == 1) idsctrl = 0;

	if(emulate == 1) {
	 if(http == 1) {
	 if(proto != 0 || proto == 1) {
	  if(port != NULL) {
	   if(twoctrl == 1) {
	    if(fourctrl == 1) {
	     if(fivectrl == 1) {

	      if(logctrl == 1) 
		 if(hex == 1)
		 emulate_main(1, port,two,four,five,logfile,1,NULL);

	      if(logctrl == 1)
		 if( hex == 0)
		 emulate_main(1, port,two,four,five,logfile,0,NULL);
		
	      if(logctrl == 0)
		 if(hex == 1) 
		 emulate_main(1, port,two,four,five,NULL,1,NULL);

	      if(logctrl == 0)
		 if(hex == 0)
		 emulate_main(1, port,two,four,five,NULL,0,NULL);
	     
	     } else {
	      fprintf(stderr, "unable to identify the 5xx fakemsg file\n");
	      fprintf(stderr, "use -5 <filename>\n");
	      exit(0);
	     }
	    } else {
	     fprintf(stderr, "unable to identify the 4xx fakemsg file\n");
	     fprintf(stderr, "use -4 <filename>\n");
	     exit(0);
	    }
	   } else {
	     fprintf(stderr, "unable to identify the 200 ok fakemsg file\n");
	     fprintf(stderr, "use -2 <filename>\n");
	     exit(0);
           }
	  } else {
	   fprintf(stderr,"unable to specify port, use -p <port num.>\n");
	   exit(0);
	  }
	 } else {
	  fprintf(stderr,"unable to specify the protocol, use -o <protocol>\n");
	  exit(0);
	 }
	}
	}

	if(emulate == 1) {
	 if(ftp == 1) {
	  if(proto != 0 || proto == 1) {
	   if(port != 0) {
		if(banctrl == 1) {
		 emulate_main(2, port,NULL,NULL,NULL,NULL,0,banner);
		} else {
		 fprintf(stderr,"unable to identify the banner file\n");
		 fprintf(stderr,"use: -n <filename>\n");
		 exit(0);
		}
	   } else {
	    fprintf(stderr,"unable to identify port, use -p <port num.>\n");
	    exit(0);
           }
	  } else {
	   fprintf(stderr,"unable to identify the protocol, use -o <protocol>\n");
	   exit(0);	  
	 }
	}
	}

	if(rawsck == 1) {
		if(proto != 0) {
			/* no reason to exit(0), since you can use
			   -r with or without -p! */
			if(port != 0)
	 			rawsock(proto,port);
			else
				rawsock(proto,NULL);
		} else {
			fprintf(stderr,"Protocol not specified\n");
		}
	}


	if(port_based == 1) {
		if(port != 0) {
			portbase(port,proto);
		} else {
			fprintf(stderr,"Port not specified\n");
		}
	}
	
	if(sniff == 1) {
		if(interface != NULL) {
			sniff_all(interface);
		} else {
			fprintf(stderr,"Interface not specified\n");
		}
	}
return 0;
}


int rawsock(int proto, char *port)
{
 if(proto == 1) { /* tcp */
	int sock, bytes, fromsiz, portctrl;
	char buffer[65535], *hdrbuff;
	struct sockaddr_in remote;
	struct ip  *ip;
	struct tcp *tcp;

	if((sock = socket(AF_INET, SOCK_RAW, IPPROTO_TCP)) < 0) {
		perror("Unable to create raw socket\n");
		exit(0);
	}
	
	while(1) {
		fromsiz = sizeof(remote);
		bytes = recvfrom(sock,buffer,sizeof(buffer),0,
				 (struct sockaddr *)&remote, &fromsiz);

		hdrbuff = buffer;
		printf("\nIP address: %s\n",inet_ntoa(remote.sin_addr));
		ip = (struct ip *)hdrbuff;
		if(ip->ip_protocol == 6) { /* tcp, then it's okay to
					      reach for tcp info */
		printf("IP header lenght: %d\n",ip->ip_lenght);
		printf("Protocol: %d\n",ip->ip_protocol);
		tcp = (struct tcp *)(buffer + (4*ip->ip_lenght));

		if(port != NULL) {
		 if(ntohs(tcp->tcp_source_port) == atoi(port)) {
		   printf("Dest/Source Port: %d,%d\n",ntohs(tcp->tcp_source_port),ntohs(tcp->tcp_dest_port));
		   printf("Checksum: %d\n",ip->ip_cksum);
		   printf("Flag: %d\n",ip->ip_flags);
		   printf("TTL: %d\n\n",ip->ip_ttl);
		   portctrl = 1;
		 }

		 if(ntohs(tcp->tcp_dest_port) == atoi(port)) {
		   printf("Dest/Source Port: %d,%d\n",ntohs(tcp->tcp_source_port),ntohs(tcp->tcp_dest_port));
		   printf("Checksum: %d\n",ip->ip_cksum);
		   printf("Flag: %d\n",ip->ip_flags);
		   printf("TTL: %d\n\n",ip->ip_ttl);
		   portctrl = 1;
		 }
		}


		if(port == NULL) {
		   printf("Dest/Source Port: %d,%d\n",ntohs(tcp->tcp_source_port),ntohs(tcp->tcp_dest_port));
		   printf("Checksum: %d\n",ip->ip_cksum);
		   printf("Flag: %d\n",ip->ip_flags);
		   printf("TTL: %d\n\n",ip->ip_ttl);
		}

		if(logctrl == 1)
		    log_rawsock(inet_ntoa(remote.sin_addr), proto,
		  	      ip->ip_lenght,ntohs(tcp->tcp_source_port),ntohs(tcp->tcp_dest_port),ip->ip_cksum,
			      ip->ip_flags,ip->ip_ttl,0);
	     }
	}
  }

  if(proto == 2) {
	int sock, bytes, fromsiz;
	char buffer[1024], *hdrbuff;
	struct sockaddr_in remote;
	struct ip	*ip;
	struct udphdr	*udp;

	if((sock = socket(AF_INET, SOCK_RAW, IPPROTO_UDP)) < 0) {
		perror("socket");
		exit(0);
	}

	while(1) {
		fromsiz = sizeof(remote);
		bytes = recvfrom(sock,buffer,sizeof(buffer),0,
				(struct sockaddr *)&remote, &fromsiz);
		hdrbuff = buffer;
		printf("\nIP address: %s\n",inet_ntoa(remote.sin_addr));
		ip = (struct ip *)hdrbuff;
		if(ip->ip_protocol == 17) {
		printf("IP header lenght: %d\n",ip->ip_lenght);
		printf("Protocol: %d\n",ip->ip_protocol);
		udp = (struct udphr *)(hdrbuff + (4*ip->ip_lenght));
		
		if(port != NULL) {
		 if(ntohs(udp->dest) == atoi(port)) {
		  printf("Dest/Source Port: %d,%d\n",ntohs(udp->dest),ntohs(udp->source));
		  printf("Checksum: %d\n",udp->check);
		  printf("Flags: %d\n",ip->ip_flags);
		  printf("TTL: %d\n\n",ip->ip_ttl);
		 }

		 if(ntohs(udp->source) == atoi(port)) {
		  printf("Dest/Source Port: %d,%d\n",ntohs(udp->dest),ntohs(udp->source));
		  printf("Checksum: %d\n",udp->check);
		  printf("Flags: %d\n",ip->ip_flags);
		  printf("TTL: %d\n\n",ip->ip_ttl);
		 }			
		}

		if(port == NULL) {
		  printf("Dest/Source Port: %d,%d\n",ntohs(udp->dest),ntohs(udp->source));
		  printf("Checksum: %d\n",udp->check);
		  printf("Flags: %d\n",ip->ip_flags);
		  printf("TTL: %d\n\n",ip->ip_ttl);
		}

		if(logctrl == 1) 
		 log_rawsock(inet_ntoa(remote.sin_addr),proto,
			    ip->ip_lenght,ntohs(udp->dest),ntohs(udp->source),udp->check,ip->ip_flags,
			    ip->ip_ttl,0);
		}
	}
 }

 if(proto == 3) {
	int sock, bytes, fromsiz;
	char buffer[1024];
	struct sockaddr_in remote;
	struct ip	*ip;
	struct icmphdr	*icmp;

	if((sock = socket(AF_INET, SOCK_RAW, 1)) < 0) {
		perror("socket");
		exit(0);
	}

	while(1) {
		fromsiz = sizeof(remote);
		bytes = recvfrom(sock,buffer,sizeof(buffer),0,
				(struct sockaddr *)&remote, &fromsiz);

		ip = (struct ip *)buffer;
		icmp = (struct icmp *)&buffer[ip->ip_lenght<<2];
		printf("IP address: %s\n",inet_ntoa(remote.sin_addr));

		/* taken from: /usr/include/linux/icmp.h */
		if(icmp->type == 0) {
		printf("icmp type: ICMP_ECHOREPLY\n\n");
		}
		if(icmp->type == 3) {
		printf("icmp type: ICMP_DEST_UNREACH\n\n");
		}
		if(icmp->type == 4) {
		printf("icmp type: ICMP_SOURCE_QUENCH\n\n");
		}
		if(icmp->type == 5) {
		printf("icmp type: ICMP_REDIRECT\n\n");
		}
		if(icmp->type == 8) {
		printf("icmp type: ICMP_ECHO\n\n");
		}
		if(icmp->type == 11) {
		printf("icmp type: ICMP_TIME_EXCEEDED\n\n");
		}
		if(icmp->type == 12) {
		printf("icmp type: ICMP_PARAMETERPROB\n\n");
		}
		if(icmp->type == 13) {
		printf("icmp type: ICMP_TIMESTAMP\n\n");
		}
		if(icmp->type == 14) {
		printf("icmp type: ICMP_TIMESTAMPREPLY\n\n");
		}
		if(icmp->type == 15) {
		printf("icmp type: ICMP_INFO_REQUEST\n\n");
		}
		if(icmp->type == 16) {
		printf("icmp type: ICMP_INFO_REPLY\n\n");
		}
		if(icmp->type == 17) {
		printf("icmp type: ICMP_ADDRESS\n\n");
		}
		if(icmp->type == 18) {
		printf("icmp type: ICMP_ADDRESSREPLY\n\n");
		}

	if(logctrl == 1)
	 log_rawsock(inet_ntoa(remote.sin_addr),proto,0,
		     0,0,0,0,0,icmp->type);
	}
 }
return 0;			
}

int portbase(char *port, int proto)
{
 if(proto == 1) { /* tcp */
	int sock_a, sock_b, porta;
	struct sockaddr_in 	local;
	struct sockaddr_in     remote;
	int sin_size, bytes;
	pid_t	pid;
	char recvbuffer[MAXBUFLEN];

	printf("protocol: tcp\n");
	printf("port:	  %s\n",port);
	if(sigctrl == 1) {
		printf("signature: %s\n",signature);
	}
	if(idsctrl == 1) {
		printf("signature file: %s\n",idsfile);
	}
	if(logctrl == 1) {
		printf("log file: %s\n",logfile);
	} 

	if((sock_a = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1) {
		perror("socket");
		exit(0);
	}

	porta = atoi(port);
	local.sin_family = 	AF_INET;
	local.sin_port   =	htons(porta);
	local.sin_addr.s_addr =	INADDR_ANY;
	bzero(&(local.sin_zero),sizeof(local));

	if(setsockopt(sock_a, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on)) < 0) {
		perror("setsockopt");
		exit(0);
	}

	if(bind(sock_a, (struct sockaddr *)&local, sizeof(struct sockaddr)) == -1) {
		perror("bind");
		exit(1);
	}

	if(listen(sock_a, BACKLOG) == -1) {
		perror("listen");
		exit(0);
	}

	while(1) {
		sin_size = sizeof(struct sockaddr_in);
		if((sock_b = accept(sock_a, (struct sockaddr *)&remote, &sin_size)) == -1) {
			perror("accept");
			exit(0);
		}

		if((pid = fork()) == 0) {
		close(sock_a);

		printf("bigeye: connection - %s\n",inet_ntoa(remote.sin_addr));
		bytes = recvtimeout(sock_b,recvbuffer,MAXBUFLEN,TIMEOUTTED);
		recvbuffer[bytes] = '\0';
		if(hex == 1) hexdump("recvbuffer",recvbuffer, strlen(recvbuffer));
		if(sigctrl == 1) {
			if(compare(recvbuffer) == 0) {
				printf("	data received: ");
			 if(bytes == -2 || bytes == -1) {
				printf("[timeout]\n");
		 	 } else {
				printf("%s\n",recvbuffer);
			 }
			printf("	bytes: [%d]\n\n",bytes);
			}

			if(logctrl == 1) log(inet_ntoa(remote.sin_addr),signature,"tcp",recvbuffer,port);
		}

		if(idsctrl == 1) { 		
			read_ids(recvbuffer);
			if(logctrl == 1) log(inet_ntoa(remote.sin_addr),idstemp,"tcp",recvbuffer,port);
		} 
		
		if(sigctrl == 0 && idsctrl == 0) {
 			 printf("	data received: ");
			 if(bytes == -2 || bytes == -1) {
				printf("[timeout]\n");
		 	 } else {
				printf("%s\n",recvbuffer);
			 }
			if(bytes == -2) { bytes = 0; }
			printf("	bytes: [%d]\n\n",bytes);
		
			if(logctrl == 1) log(inet_ntoa(remote.sin_addr),NULL,"tcp",recvbuffer,port);
		}
		memset(recvbuffer, 0x00,bytes);
		close(sock_b);
		exit(0);
		}
	close(sock_b);
	}
	close(sock_a);
 }

 if(proto == 2) {
	int sock_a, bytes, porta, fromlen;
	struct sockaddr_in 	local;
	struct sockaddr_in	remote;
	char recvbuffer[MAXBUFLEN]; 

	printf("protocol: udp\n");
	printf("port: %s\n",port);
	if(sigctrl == 1) printf("signature: %s\n", signature);
	if(idsctrl == 1) printf("signature file: %s\n",idsfile);
	if(logctrl == 1) printf("log file: %s\n",logfile);

	if((sock_a = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		perror("socket");
		exit(0);
	}

	porta = atoi(port);
	bzero(&local,sizeof(local));
	local.sin_family	= AF_INET;
	local.sin_port		= htons(porta);
	local.sin_addr.s_addr	= htonl(INADDR_ANY);

	if(setsockopt(sock_a, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on)) < 0) {
		perror("setsockopt");
		exit(0);
	}
	
	if(bind(sock_a, (struct sockaddr *)&local, sizeof(local)) < 0) {
		perror("bind");
		exit(0);
	}
  while(1) {	
	fromlen = sizeof(remote);
	bytes = recvfrom(sock_a, recvbuffer, sizeof(recvbuffer), 0,
			(struct sockaddr *)&remote, &fromlen);
	if(bytes < 0) perror("recvfrom");
	printf("bigeye: connection - %s\n",inet_ntoa(remote.sin_addr));
	recvbuffer[bytes] = '\0';
	
	if(hex == 1) hexdump("recvbuffer",recvbuffer, strlen(recvbuffer));
	if(sigctrl == 1) {
	 if(compare(recvbuffer) == 0) {
			printf("	data received: ");
		 if(bytes < 0) {
			printf("[timeout]\n");
	 	 } else {
			printf("%s\n",recvbuffer);
		 }
			printf("	bytes: [%d]\n\n",bytes);
		if(logctrl == 1) log(inet_ntoa(remote.sin_addr),signature,"udp",recvbuffer,port);
	 }
      	} 

	if(idsctrl == 1) {
		read_ids(recvbuffer);
		if(logctrl == 1) log(inet_ntoa(remote.sin_addr),idstemp,"udp",recvbuffer,port);
	}
	
	if(sigctrl == 0 && idsctrl == 0) {
 		 printf("	data received: ");
		 if(bytes < 0) {
			printf("[timeout]\n");
	 	 } else {
			printf("%s\n",recvbuffer);
		 }
		 if(bytes == -2) { bytes = 0; }
			printf("	bytes: [%d]\n\n",bytes);
		if(logctrl == 1) log(inet_ntoa(remote.sin_addr),NULL,"udp",recvbuffer,port);
	}
 	recvbuffer[bytes] = '\0';
	memset(recvbuffer, 0x00, bytes);
  }
}

 if(proto == 3) { 
	fprintf(stderr,"icmp protocol not supported on -b option\n");
	exit(0);
 }

return 0;
}			

int sniff_all(char *interface) {
	char buff[1024];
	struct ifreq ifr;
	int sock, bytes;

	if((sock = socket(PF_INET, SOCK_PACKET, htons(0x0003))) < 0) {
		perror("socket");
		exit(0);
	}

	strncpy(ifr.ifr_name, interface, sizeof(interface));
	if(ioctl(sock, SIOCGIFFLAGS, &ifr) < 0) {
		perror("ioctl");
		exit(0);
	}

	ifr.ifr_flags |= IFF_PROMISC;
	if(ioctl(sock, SIOCGIFFLAGS, &ifr) < 0) {
		perror("ioctl");
		exit(0);
	}

	printf("capturing data... \n");
	printf("interface: %s\n", interface);
	fflush(stdout);

	for(;;) {
		bytes = read(sock, buff, sizeof(buff));
		if(bytes != 1) {
		 /* if(sigctrl == 1) {
		     if(compare(buff) == 0) { 
			write(STDOUT_FILENO, buff, bytes);
		  }
                 } else {
		  printf("signal off\n"); */
		  write(STDOUT_FILENO, buff, bytes);
		}
	}
	
	ifr.ifr_flags &= ~IFF_PROMISC;
	if(ioctl(sock, SIOCSIFFLAGS, &ifr) < 0) {
		perror("ioctl");
		exit(0);
	}

	close(sock);
	printf("done... bytes captured[%d]\n",bytes -1);
return 0;
}		  
			
int compare(char *buff) {
	if(strstr(buff,signature)) {
		printf("*** SIGNATURE FOUND\n");
	/* here is were you put your own code, that will
	   deal with the packet that HAS your signature
	   inside it */
		return 0;
	} else {	return 1; }
/* never reached */
}

int recvtimeout(int s, char *buf, int len, int timeout)
{
 fd_set fds;
 int n;
 struct timeval tv;
 FD_ZERO(&fds);
 FD_SET(s,&fds);
 tv.tv_sec = timeout;
 tv.tv_usec = 0;

 n=select(s+1,&fds,NULL,NULL,&tv);
 if(n ==  0) { return -2;}
 if(n == -1) { return -1;}
 return recv(s,buf,len,0);
}

/* the same as the perl variant, ripped from: nmap-2.54/util.c
   kuabanga, cowboys! 

	it gets a string that comes with a \n at the end of it
	and rip it off, leave the string terminated with a \0.
	mainly because fgets()... bah!
*/
char *chomp(char *string) {
 int len;

 len = strlen(string);
 if(len < 1) 
	return string; /* no lenght? */

 if(string[len-1] != '\n')
	return string;

 if(len > 1 && string[len-2] == '\r')
	string[len-2] = '\0';
 else
	string[len-1] = '\0';
 return string;
}

int read_ids(char *recvbuff) {
 FILE *fp;
 char buff[1024];
 int len;

 if((fp = fopen(idsfile,"r")) == NULL) {
	perror("fopen");
	exit(0);
 }

 while(fgets(buff, sizeof(buff),fp) != NULL) {
	chomp(buff);
	if(strstr(buff," ")) {
		/* printf("NULL CHARACTER INSIDE RULES FILE\n");
		   exit(0); */
	} else {

	if(strstr(recvbuff,buff)) {
		len = strlen(buff);
		printf("*** SIGNATURE FOUND\n");
		printf("signature: %s\n",buff);
		printf("data received: %s\n",recvbuff);
		strncpy(idstemp,buff,strlen(buff));
		idstemp[len] = '\0';
		if(idstemp == NULL) nullids = 1;
	}
	}
 }
 fclose(fp);
 return 0;
}


/* ripped from zodiac, 7350's code */
void hexdump (char *desc, unsigned char *data, unsigned int amount)
{
        unsigned int    dp, p;  /* data pointer */
        const char      trans[] =
                "................................ !\"#$%&'()*+,-./0123456789"
                ":;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklm"
                "nopqrstuvwxyz{|}~...................................."
                "....................................................."
                "........................................";


        printf ("/* %s, %u bytes */\n", desc, amount);

        for (dp = 1; dp <= amount; dp++) {
                fprintf (stderr, "%02x ", data[dp-1]);
                if ((dp % 8) == 0)
                        fprintf (stderr, " ");
                if ((dp % 16) == 0) {
                        fprintf (stderr, "| ");
                        p = dp;
                        for (dp -= 16; dp < p; dp++)
                                fprintf (stderr, "%c", trans[data[dp]]);
                        fflush (stderr);
                        fprintf (stderr, "\n");
                }
                fflush (stderr);
        }
        if ((amount % 16) != 0) {
                p = dp = 16 - (amount % 16);
                for (dp = p; dp > 0; dp--) {
                        fprintf (stderr, "   ");
                        if (((dp % 8) == 0) && (p != 8))
                                fprintf (stderr, " ");
                        fflush (stderr);
                }
                fprintf (stderr, " | ");
                for (dp = (amount - (16 - p)); dp < amount; dp++)
                        fprintf (stderr, "%c", trans[data[dp]]);
                fflush (stderr);
        }
        fprintf (stderr, "\n\n");

        return;
}

void log(char *connection, char *signature, char *protocol, char *data, char *port) {
 FILE *fp;

 if((fp = fopen(logfile,"a")) == NULL) {
	 perror("fopen");
	 exit(0);
 }

 lt = time(NULL);
 ptr = localtime(&lt);

 fprintf(fp, "IP address: %s - time: %sPort: %s - Protocol: 
%s\n",connection,asctime(ptr),port,protocol);
 if(emulate == 1 && signature != NULL)  fprintf(fp,"server response: %s\n",signature);
 if(emulate == 0 && signature != NULL)	fprintf(fp,"server response: %s\n",signature);
 if(sigctrl == 1 && signature != NULL)  fprintf(fp,"signature: %s\n",signature);
 if(idsctrl == 1 && nullids == 1)  fprintf(fp,"signature: %s\n",signature);

 if(data != NULL) fprintf(fp, "Data received: %s\n", data);
 fprintf(fp, "---------------------------\n\n");
 fclose(fp);
}

void log_rawsock(char *connection, int proto, int lenght,
		 int source_port, int dest_port, int cksum,
		 int flag, int ttl, int icmp_type) {
  FILE *fp;

 if((fp = fopen(logfile,"a")) == NULL) {
	 perror("fopen");
	 exit(0);
 }

 lt = time(NULL);
 ptr = localtime(&lt);


 if(proto == 1) {
	fprintf(fp,"IP address: %s - time: %s",connection,asctime(ptr));
	fprintf(fp,"protocol: tcp -- ip_lenght: %d\n",lenght);
	fprintf(fp,"dest port: %d -- source port: %d\n",dest_port,source_port);
	fprintf(fp,"chksum: %d -- flag: %d -- ttl: %d\n",cksum,flag,ttl);
	fprintf(fp,"--------------------------\n\n");	
 }

 if(proto == 2) {
	fprintf(fp,"IP address: %s - time: %s",connection,asctime(ptr));
	fprintf(fp,"protocol: udp -- ip_lenght: %d\n",lenght);
	fprintf(fp,"dest port: %d -- source port: %d\n",dest_port,source_port);
	fprintf(fp,"chksum: %d -- flag: %d -- ttl: %d\n",cksum,flag,ttl);
	fprintf(fp,"--------------------------\n\n");	
 }

 if(proto == 3) {
	fprintf(fp,"IP address: %s - time: %s",connection,asctime(ptr));
	fprintf(fp,"ICMP type: %d\n",icmp_type);
	fprintf(fp,"--------------------------\n\n");
 }

 fclose(fp);
}

int 
demon(void) {
/* w. richard stevens implementation */
int	i;
pid_t	pid;

	if( ( pid = fork()) != 0) 
		exit(0);

	setsid();
	signal(SIGHUP,SIG_IGN);

	if( ( pid = fork()) != 0)
		exit(0);

	umask(0);
	for( i = 0; i < MAXFD; i++)
		close(i);

return 0;
}

void usage(char *program)
{
	fprintf(stderr,"Usage:\n");
	fprintf(stderr,"  %s <-b/-r/-S/-e service> <-o protocol> [-i device] [-p port] [-s string] [-d/-x]\n",program);
	fprintf(stderr,"     [-2 filename/-4 filename/-5 filename] [-n filename] [-l <logfile>] [-f <filename>] [-h]\n");
	fprintf(stderr," modules:\n");
	fprintf(stderr,"  -e   <service>: emulate a service (honeypot)\n");
	fprintf(stderr,"	      -b: port-based\n");
	fprintf(stderr,"	      -r: raw socket style (header dump)\n");
	fprintf(stderr,"	      -S: raw (no treatment) sniffer (data dump)\n\n");
	fprintf(stderr," rawsock,port-based,emulate {\n");
	fprintf(stderr,"  -o  <protocol>: specifies the protocol to use\n");
	fprintf(stderr,"  -p      <port>: specifies the port to listen (only\n");
	fprintf(stderr,"                  with -b/-e/-r options)\n");
	fprintf(stderr," }\n\n");
	fprintf(stderr," port-based {\n");
	fprintf(stderr,"  -s    <string>: string to search inside received\n");
	fprintf(stderr,"                  packets\n");
	fprintf(stderr,"  -f <rule file>: file that have strings to search (as oppose to\n");
	fprintf(stderr,"		  only looking for one (-s))\n");
	fprintf(stderr," }\n\n");
	fprintf(stderr," sniffer {\n");
	fprintf(stderr,"  -i <interface>: interface to set promisc (-S option)\n");
	fprintf(stderr," }\n\n");
	fprintf(stderr," emulate {\n");
	fprintf(stderr,"  -2  <filename>: specify the http 200 file to read (only with -e)\n");
	fprintf(stderr,"  -4  <filename>: specify the http 4xx file to read (only with -e)\n");
	fprintf(stderr,"  -5  <filename>: specify the http 5xx file to read (only with -e)\n");
	fprintf(stderr,"  -n  <filename>: specify the banner file to read (only with -e ftp)\n");
	fprintf(stderr,"  -L  <filename>: specify the directory list file to read (only with -e ftp)\n");
	fprintf(stderr," }\n\n");
	fprintf(stderr," misc {\n"); 
	fprintf(stderr,"  -l   <logfile>: sets the log file\n");
	fprintf(stderr,"	      -d: daemon function (detach from console)\n");
	fprintf(stderr,"	      -x: dump data received in hex format\n");
	fprintf(stderr," 	      -h: print this message\n\n");
	fprintf(stderr," }\n");
}
